module Backend
  module API
    module Schema
      @[GraphQL::Object]
      class Admin < GraphQL::BaseObject
        include Helpers::DbObject

        db_object Db::Admin

        @[GraphQL::Field]
        def user : User
          User.new(find!.user)
        end
      end

      @[GraphQL::InputObject]
      class AdminCreateInput < GraphQL::BaseInputObject
        getter user_id

        @[GraphQL::Field]
        def initialize(@user_id : Int32)
        end
      end
    end
  end
end
