require "quartz_mailer"
require "email"
require "kilt"

require "./mailers/*"

module Backend
  module Mailers
    NAME  = SAFE_ENV["BACKEND_SMTP_NAME"]
    EMAIL = SAFE_ENV["BACKEND_SMTP_USERNAME"]

    Quartz.config do |config|
      config.smtp_enabled = true
      config.smtp_address = SAFE_ENV["BACKEND_SMTP_ADDRESS"]
      config.smtp_port = SAFE_ENV["BACKEND_SMTP_PORT"]
      config.helo_domain = SAFE_ENV["BACKEND_SMTP_HELO"]
      config.use_tls = EMail::Client::TLSMode::STARTTLS
      config.username = EMAIL
      config.password = SAFE_ENV["BACKEND_SMTP_PASSWORD"]
      config.use_authentication = true
    end
  end
end
