module Backend
  extend self

  def run : Nil
    Log.info { "Starting backend services..." }

    channel = Channel(Nil).new(SERVICES.size)

    SERVICES.each do |service|
      spawn do
        service.call
        channel.send(nil)
      end
    end

    SERVICES.size.times do
      channel.receive
    end
    Fiber.yield
    Log.info { "Backend services started." }
  end
end
