require "mosquito"

module Mosquito::Serializers::Array
end

module Mosquito::Serializers::Granite
  macro serialize_granite_model(klass)
    {% method_suffix = klass.resolve.stringify.underscore.gsub(/::/, "__").id %}

    def serialize_{{ method_suffix }}(model : {{ klass.id }}) : String
      model.id.to_s
    end

    def deserialize_{{ method_suffix }}(raw : String) : {{ klass.id }}
      id = raw.to_i
      {{ klass.id }}.find(id).not_nil!
    end
  end
end

require "./worker/*"

module Backend
  module Worker
    Mosquito.configure do |settings|
      settings.redis_url = SAFE_ENV["BACKEND_WORKER_REDIS_URL"]
    end
  end
end
